=== debian/changelog ===
libtins (4.0-1build2) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 23 Nov 2021 17:59:52 +0100

libtins (4.0-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:18:33 +0100

libtins (4.0-1) unstable; urgency=medium

  * New upstream release (Closes: #897440)
  * Add dependency (Closes: #894343)

 -- Federico Ceratto <federico@debian.org>  Wed, 19 Sep 2018 22:31:41 +0100
