=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export V=1  # verbose mode for make
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,--no-undefined,--no-add-needed
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

override_dh_auto_build:
	mkdir -p build
	cd build && cmake ../ -DLIBTINS_ENABLE_CXX11=1
	cd build && make

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

override_dh_auto_clean:
	rm build -rf
	dh_auto_clean
