## libtins 4.5

=== debian/changelog ===
libtins (4.5-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:47:29 +0000

libtins (4.5-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:29:00 +0000

libtins (4.5-1) unstable; urgency=medium

  * New upstream release (Closes: #1050161)
  * Add multiarch support (Closes: #1024945)
    Kudos to Helmut Grohne

 -- Federico Ceratto <federico@debian.org>  Thu, 15 Feb 2024 17:26:17 +0100
