=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: libtins
 Priority: optional
-Maintainer: Internet Measurement Packaging Team <pkg-netmeasure-discuss@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Internet Measurement Packaging Team <pkg-netmeasure-discuss@lists.alioth.debian.org>
 Uploaders: Federico Ceratto <federico@debian.org>
-Build-Depends: debhelper (>=11~),
+Build-Depends: debhelper-compat (= 13),
  cmake,
  libpcap-dev,
  libssl-dev
@@ -12,7 +13,7 @@
 Vcs-Git: https://salsa.debian.org/debian/libtins.git
 Vcs-Browser: https://salsa.debian.org/debian/libtins
 
-Package: libtins4.0
+Package: libtins4.5
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: packet crafting and sniffing library
@@ -25,7 +26,7 @@
 Package: libtins-dev
 Section: libdevel
 Architecture: any
-Depends: libtins4.0 (= ${binary:Version}), ${misc:Depends}, libpcap-dev
+Depends: libtins4.5 (= ${binary:Version}), ${misc:Depends}, libpcap-dev
 Description: packet crafting and sniffing library - development files
  libtins is a high-level, multiplatform C++ network packet sniffing and
  crafting library.
@@ -33,4 +34,3 @@
  and endianess-independent way to create tools which need to send, receive and
  manipulate network packets.
  This package contains development files.
-
